------------------------------------------------------------------------------------
------------------- L E V E L   H A N D L E R   I N I T I A L I Z E ----------------
------------------------------------------------------------------------------------

level_handler = {}

function level_handler:init()

	--LEVEL BOUNDS

	self.stage = 1

	self.stage_complete = false
	self.stage_ongoing = false

	self.isDebuggingStage = false
	self.isDebuggingPlayer = false
	
	self.bounds = {}
	self.mainStage = {}

	self.event_container = {}
	self.event_handler = {}


end

------------------------------------------------------------------------------------
---------------------------- C R E A T E   H A N D L E R ---------------------------
------------------------------------------------------------------------------------

function level_handler:create_world()

	if self.stage == 1 and self.stage_complete == false and self.stage_ongoing == false then
		self.stage_ongoing = true
		self.mainStage = level_outline.one

		self:create_bounds()
	end

end

------------------------------------------------------------------------------------
---------------------------- C R E A T E   B O U N D S -----------------------------
------------------------------------------------------------------------------------

function level_handler:create_bounds()
	for k,v in pairs(self.bounds) do self.bounds[k]=nil end

	for i = 1, #self.mainStage do
		for ii = 1, #self.mainStage[i] do
			if self.mainStage[i][ii] ~= 0 then
				table.insert(self.bounds, {ii * level_outline.s - level_outline.s, i * level_outline.s - level_outline.s })
			end
		end
	end

end

------------------------------------------------------------------------------------
---------------------- D R A W   W O R L D   B A C K G R O U N D -------------------
------------------------------------------------------------------------------------

function level_handler:draw_world()

	if self.stage == 1 then
		love.graphics.setColor(255,255,255,255)
		love.graphics.draw(level_one_bg, 0, 0)
	end

end

------------------------------------------------------------------------------------
------------------------------- D R A W  B O U N D S -------------------------------
------------------------------------------------------------------------------------

function level_handler:draw_bounds()
	local lgr, setcol, l, f = love.graphics.rectangle, love.graphics.setColor, "line", "fill"

	if self.isDebuggingStage == true then

		for y, v in ipairs(self.mainStage) do
			for x, tile in ipairs(v) do
				if tile == 1 then

					setcol(50,50,150,100)
					lgr(f, (x - 1) * level_outline.w,
						(y - 1) * level_outline.h,
						level_outline.w, level_outline.h)

					lgr(l, (x - 1) * level_outline.w,
						(y - 1) * level_outline.h,
						level_outline.w, level_outline.h)

				end
			end
		end
	end
end

------------------------------------------------------------------------------------
------------------------ U P D A T E   E V E R Y T I N G ---------------------------
------------------------------------------------------------------------------------

function level_handler:update(dt)
	self:create_world()
end

function level_handler:draw()
	self:draw_world()
	self:draw_bounds()
end