function love.load()
	require "level-container"
	require "level-handler"
	require "player"

	--globals
	screen_w, screen_h = love.graphics.getWidth(), love.graphics.getHeight()

	--graphics
	level_one_bg = love.graphics.newImage("gfx/level_one.png")
	event_mark = love.graphics.newImage("gfx/event-exclamation.png")

	custom_font = love.graphics.newImageFont("gfx/font.png",
    " abcdefghijklmnopqrstuvwxyz" ..
    "ABCDEFGHIJKLMNOPQRSTUVWXYZ0" ..
    "123456789.,!?-+/():;%&`'*#=[]\"")
	love.graphics.setFont(custom_font)
	
	--class init
	level_outline:init() -- prepare level outlines

	level_handler:init() -- prepare stage
	player:init() --initialize player parameters

end

function love.update(dt)

	--pass the outline of the stage, check if the stage is finished, update and create bounds for it
	level_handler:update(dt)
	--update controls and player functions
	player:update(dt)

end

function love.draw()

	--draw level design, draw bounding boxes if debugging is true
	level_handler:draw()
	--draw player sprite and collision box if debugging is true
	player:draw()

	-- An idea of what the GUI should look like
	love.graphics.setColor(255,255,255,255)
	levelgui = love.graphics.print("Level: " .. player.level , 5, screen_h-50)

	love.graphics.print("HP: " .. player.curhp .. " / " .. player.maxhp, 5, screen_h-35)
	love.graphics.print("CT Bar :: ", 5, screen_h-20)
	love.graphics.print("GO", screen_w - 40, screen_h-27)

	love.graphics.setColor(50, 0, 50, 255)
	love.graphics.circle("line", screen_w - 30, screen_h - 20, 20, 6)
	love.graphics.rectangle("line", 115, screen_h - 17, 470, 12)

end

function love.keypressed(key)
	--Check player keypresses
	player:keypressed(key)
end

function love.keyreleased(key)
	--Stop animation after moving...
	player:stopped_moving(key)
end