------------------------------------------------------------------------------------------------]]
------------------------------ E V E N T    I N I T I A L I Z E --------------------------------]]
------------------------------------------------------------------------------------------------]]

allow_debug = true
done_creating_events = false
run_event = false
event_container = {}
event_container.messages = {}
event_container.draw_debug = {}

------------------------------------------------------------------------------------------------]]
-------------------------------- E V E N T  F U N C T I O N S ----------------------------------]]
------------------------------------------------------------------------------------------------]]

function stepping_on_event(event_x, event_y, event_width, event_height)
	if player.x + player.w >= event_x and
		player.x <= event_x + event_width and
		player.y + player.h >= event_y and
		player.y + player.oy <= event_y + event_height then
		return true
	end
	return false
end


function draw_event_debug(event_x, event_y, event_width, event_height)
	love.graphics.setColor(0, 125, 50, 100)
	love.graphics.rectangle("fill", event_x, event_y, event_width,event_height)
	love.graphics.rectangle("line", event_x, event_y, event_width,event_height)
end

function reset_event()
	run_event = false
	done_creating_events = true
	player.isRunningEvent = false
	player.msg_counter = 0
end

------------------------------------------------------------------------------------------------]]
-------------------------------- M E S S A G E   E V E N T S -----------------------------------]]
------------------------------------------------------------------------------------------------]]

function show_popup_message(x, y, text, col1, col2, col3, alp)
	local w = #text * 12
	local h = 50

	love.graphics.setColor(col1 or 0, col2 or 50, col3 or 100, alp or 150)
	love.graphics.rectangle("fill", x, y, w, h)

	love.graphics.setColor(0, 0, 0, 255)
	love.graphics.rectangle("line", x, y, w, h)

	love.graphics.setColor(255,255,255,255)
	love.graphics.print(text, x+#text/2, y+15)
end

------------------------------------------------------------------------------------------------]]
--------------------------------- E V E N T   U P D A T E S ------------------------------------]]
------------------------------------------------------------------------------------------------]]

function event_updates()
	if level_handler.stage == 1 then

		if stepping_on_event(192, 96, 256, 32) and player.dir == "up" then 
			--for i = 1, #event_container.messages do event_container.messages[i] = nil end
			event_container.messages[1] = "Such a nice view up here"
		elseif stepping_on_event(160, 224, 32, 96) then
			event_container.messages[1] = "I can see a town from up here"
			event_container.messages[2] = "It has a huge windmill in it!"
		end
	end

	if done_creating_events then
		for i = 1, #event_container.messages do event_container.messages[i] = nil end
		done_creating_events = false
	end
end

------------------------------------------------------------------------------------------------]]
------------------------------ L I S T     O F     E V E N T S ---------------------------------]]
------------------------------------------------------------------------------------------------]]
--  This is where all the event is processed       -                                            --
--------------------------------------------------------------------------------------------------

function event_draw()
	local player_popup = player.x - player.x/2

	if level_handler.stage == 1 then
		--DEBUG
		if allow_debug == true then
			event_container.draw_debug[1] = draw_event_debug(192, 96, 256, 32)
			event_container.draw_debug[2] = draw_event_debug(128, 192, 32, 96)
		end
		--MAIN
		if stepping_on_event(192, 96, 256, 32) and player.dir == "up" and run_event then
			player.isRunningEvent = true
			if run_event and player.msg_counter > #event_container.messages then 
				reset_event()
			else 
				show_popup_message(player_popup, player.y-55, event_container.messages[player.msg_counter])
			end
		end

		if stepping_on_event(128, 192, 32, 96) and player.dir == "left" and run_event then
			player.isRunningEvent = true
			if run_event and player.msg_counter > #event_container.messages then
				reset_event()
			else
				show_popup_message(player_popup, player.y-55, event_container.messages[player.msg_counter])
			end
		end
	end
end
